<template>
  <AccordionFieldset
    class="occupation-income-accordion-fieldset"
    label="Activité/Revenu"
  >
    <div class="fr-container--fluid">
      <div class="fr-grid-row fr-grid-row--gutters form-grid">
        <AtomSelect
          name="socio_professional_category"
          label="Catégorie socio-professionnelle"
          :options="withEmptyValue(SOCIO_PROFESSIONAL_CATEGORY_OPTIONS)"
          :model-value="beneficiary?.socio_professional_category || ''"
        />
        <AtomInput
          name="occupation"
          label="Profession(s)"
          :value="beneficiary?.occupation || ''"
        />
        <AtomInput
          name="employer"
          label="Employeur"
          :value="beneficiary?.employer || ''"
        />
        <AtomInput
          name="employer_siret"
          label="SIRET de l'employeur"
          :value="beneficiary?.employer_siret || ''"
        />
        <AtomMultiSelect
          name="main_income_type"
          label="Natures des ressources"
          :options="INCOME_TYPE_OPTIONS"
          :model-value="beneficiary?.main_income_type || []"
          label-class="fr-text--regular"
          dropdown
        />
        <AtomCurrencyInput
          name="main_income_amount"
          label="Montant des ressources"
          :value="beneficiary?.main_income_amount || ''"
        />
        <AtomMultiSelect
          v-show="hasPartner"
          name="partner_main_income_type"
          label="Natures des ressources du conjoint"
          :options="INCOME_TYPE_OPTIONS"
          :model-value="beneficiary?.partner_main_income_type || []"
          label-class="fr-text--regular"
          dropdown
        />
        <AtomCurrencyInput
          v-show="hasPartner"
          name="partner_main_income_amount"
          label="Montant des ressources du conjoint"
          :value="beneficiary?.partner_main_income_amount || ''"
        />
        <AtomMultiSelect
          v-show="majorChildrenNb"
          name="major_children_main_income_type"
          label="Natures des ressources des enfants majeurs"
          :options="INCOME_TYPE_OPTIONS"
          :model-value="beneficiary?.major_children_main_income_type || []"
          label-class="fr-text--regular"
          dropdown
        />
        <AtomCurrencyInput
          v-show="majorChildrenNb"
          name="major_children_main_income_amount"
          label="Montant des ressources des enfants majeurs"
          :value="beneficiary?.major_children_main_income_amount || ''"
        />
        <AtomInput
          name="pole_emploi"
          label="N° Pôle Emploi"
          :value="beneficiary?.pole_emploi || ''"
        />
        <AtomMultiSelect
          v-model="pensionOrganisations"
          name="pension_organisations"
          label="Organismes de retraite"
          :options="PENSION_ORGANISATION_OPTIONS"
          label-class="fr-text--regular"
          dropdown
        />
        <AtomInput
          v-if="hasOtherPensionOrganisations"
          name="other_pension_organisations"
          label="Autre(s) organisme(s) de retraite"
          :value="initialOtherPensionOrganisations"
        />
        <AtomInput
          name="caf"
          label="N° CAF"
          :value="beneficiary?.caf || ''"
        />
        <AtomInput
          name="bank"
          label="Banque"
          :value="beneficiary?.bank || ''"
        />
        <AtomInput
          name="funeral_contract"
          label="Contrat obsèques"
          :value="beneficiary?.funeral_contract || ''"
        />
        <template v-if="isMinistryAgent">
          <AtomSelect
            name="ministere_categorie"
            label="Catégorie"
            :options="withEmptyValue(MINISTERE_CATEGORIE_OPTIONS)"
            :model-value="beneficiary?.ministere_categorie || ''"
          />
          <AtomSearchableSelect
            name="ministere_departement_service_ac"
            label="Département ou service de l'Administration Centrale"
            :options="MINISTERE_DEPARTEMENT_SERVICE_AC_OPTIONS"
            :value="beneficiary?.ministere_departement_service_ac || ''"
          />
          <AtomSelect
            name="ministere_structure"
            label="Structure de rattachement"
            :options="withEmptyValue(MINISTERE_STRUCTURE_OPTIONS)"
            :model-value="beneficiary?.ministere_structure || ''"
          />
        </template>
      </div>
    </div>
  </AccordionFieldset>
</template>

<script lang="ts" setup>
  import {
    PARTNER_FAMILY_SITUATION_VALUES,
    SOCIO_PROFESSIONAL_CATEGORY_OPTIONS,
    INCOME_TYPE_OPTIONS,
    PENSION_ORGANISATION_OPTIONS,
    MINISTERE_STRUCTURE_OPTIONS,
    MINISTERE_DEPARTEMENT_SERVICE_AC_OPTIONS,
    MINISTERE_CATEGORIE_OPTIONS,
    PensionOrganisation
  } from '~/utils/constants/beneficiary'
  import type { Beneficiary } from '~/types/beneficiary'
  import { withEmptyValue } from '~/utils'

  const isMinistryAgent = useMinistryAgent()

  const props = withDefaults(
    defineProps<{
      beneficiary?: Beneficiary | null
      familySituation: string
      majorChildrenNb: number
    }>(),
    { beneficiary: null }
  )

  // Filter other pension organisations input from free field
  const beneficiaryPensionOrganisations =
    props.beneficiary?.pension_organisations?.filter(org =>
      PENSION_ORGANISATION_OPTIONS.has(org)
    )
  const pensionOrganisations = ref<string[]>(
    beneficiaryPensionOrganisations || []
  )

  const hasPartner = computed(() =>
    PARTNER_FAMILY_SITUATION_VALUES.includes(props.familySituation)
  )

  const hasOtherPensionOrganisations = computed(() =>
    pensionOrganisations.value.includes(PensionOrganisation.Other)
  )

  const initialOtherPensionOrganisations = computed(() => {
    if (!hasOtherPensionOrganisations.value) return ''
    return props.beneficiary?.pension_organisations?.find(
      org => !PENSION_ORGANISATION_OPTIONS.has(org)
    )
  })
</script>

<style>
  /* Allow to display ministere_departement_service_ac searchable select options within the accordion, as overflow is hidden */
  .occupation-income-accordion-fieldset.fr-accordion .fr-collapse--expanded {
    padding-bottom: 9.625rem;
  }
</style>
